<?php

require_once("../helper.php");

$heatQuery = "SELECT
UNIX_TIMESTAMP(Heater.datetime) AS time, 
PufferU AS 'Speicher unten',
PufferM AS 'Speicher mitte',
PufferO AS 'Speicher oben',


thermeVLfb AS 'Therme Vorlauf Fußboden',
thermeRL AS 'Therme Rücklauf',
heaterVL AS 'Heizstab Vorlauf',
heaterRL AS 'Heizstab Rücklauf',
fbVL AS 'Fußboden Vorlauf',
fbRL AS 'Fußboden Rücklauf'
FROM Heater
WHERE Heater.datetime BETWEEN DATE_SUB(NOW(),INTERVAL 24 HOUR) and NOW()
ORDER BY Heater.datetime";

$waterQuery = "SELECT UNIX_TIMESTAMP(wasser.datetime) AS time, rate AS 'Wasserverbrauch' 
FROM solarLog.wasser 
WHERE wasser.datetime BETWEEN DATE_SUB(NOW(),INTERVAL 24 HOUR) and NOW()
ORDER BY wasser.datetime";

$linecolors["Speicher oben"] = "#FF5500";
$linecolors["Speicher mitte"] = "#FFaa00";
$linecolors["Speicher unten"] = "#FFFF00";
$linecolors["Therme Vorlauf Fußboden"] = "#bb0000";
$linecolors["Therme Rücklauf"] = "#ee0000";
$linecolors["Heizstab Vorlauf"] = "#9900bb";
$linecolors["Heizstab Rücklauf"] = "#8800aa";
$linecolors["Fußboden Vorlauf"] = "#00FF00";
$linecolors["Fußboden Rücklauf"] = "#00aa00";
$linecolors["Wasserverbrauch"] = "#2222FF";



if (checkLogin()) {
    $mysql = new mysqli($mysql_server, $mysql_solarUser, $mysql_solarPass, $mysql_solarDB);
    $result = mysqli_query($mysql, $heatQuery);
    $simRes = mysqli_query($mysql,$waterQuery);
    if(!$result){
        echo "Error:<br>".mysqli_error($mysql)."<br />";
    }
    $obj = (object)[]; // Cast empty array to object
    $obj->labels = [];
    $obj->datasets = [];
    $i = 0;
    $filled = 0;

    if ($result->num_rows > 1) {
        $ii = 0;
        $row = $result->fetch_assoc();
        foreach ($row as $name => $value) {
            $dataset = (object)[];
            if ($name != "time") {
                $dataset->borderColor = $linecolors[$name];
                $dataset->backgroundColor = $linecolors[$name]."22";
                $dataset->borderWidth=2;
                $dataset->pointRadius= 0;
                $dataset->pointHoverRadius= 5;
                $dataset->tension=0.2;
                if(strpos($name,"Speicher") === false) {
                    $dataset->fill = "none";
                } else {
                   // $dataset->stack = "Consumers";
                    if ($filled == 0) {
                        $filled = 1;
                        $dataset->fill = "origin";
                    } else {
                        $dataset->fill = "-1";
                    }
                    $dataset->yAxisID = 'y';
                }
                $dataset->label = $name;

                $dataset->data[] = $value;
                $obj->datasets[] = clone $dataset;
                $ii++;
            } else {
                $obj->labels[] = $value * 1000;
            }
        }
        while ($row = $result->fetch_assoc()) {
            $ii = 0;
            foreach ($row as $name => $value) {
                if ($name != "time") {
                    $obj->datasets[$ii]->data[] = $value;
                    $ii++;
                } else {
                    $obj->labels[] = $value * 1000;
                }
            }
        }
    }
  

}


//header('Content-Type: application/json');
echo json_encode($obj);
//echo '{"labels":[1761322682000,1761322782000,1761322882000,1761322982000,1761323082000,1761323182000,1761323282000],"datasets":[{"stack": "Stack 0","cubicInterpolationMode":"monotone","fill":"origin","label":"Acquisitions by year","data":[10,20,50,20,10,5,70]},{"fill": "false","stack": "Stack 1","cubicInterpolationMode": "monotone","label": "Acquisitions by year","data": [10,20,50,20,10,5,70]}]}';
